=== include/CMakeLists.txt ===
if (GINKGO_CHECK_CIRCULAR_DEPS)
    add_library(ginkgo_public_api INTERFACE) # dummy target
    target_link_libraries(ginkgo_public_api INTERFACE hwloc)
    set_property(TARGET ginkgo_public_api APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}")
    set_property(TARGET ginkgo_public_api APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_BINARY_DIR}")
    ginkgo_check_headers(ginkgo_public_api "")
endif()
